
"""
Test simultaneous diagonalisation
"""

import numpy
import scipy.linalg


numCols = 5
A = numpy.random.rand(3, numCols)
A = numpy.dot(A.T, A)

b = numpy.random.rand(numCols)
B = numpy.diag(b)

k = 3
s, U = numpy.linalg.eig(A)
inds = numpy.flipud(numpy.argsort(numpy.abs(s)))
U = U[:, inds[0:k]]
s = s[inds[0:k]]

Uhat = numpy.dot(U, numpy.diag(s**-0.5))
K = numpy.dot(Uhat.T, numpy.dot(A, Uhat))
#Should be identity 
print(K)


L = Uhat.T.dot(B.dot(Uhat))
t, V = numpy.linalg.eig(L)

print(Uhat)
print(V)

T = Uhat.dot(V)

T = T.dot(numpy.diag(numpy.diag(T.T.dot(T))**-0.5)) 
print(T.T.dot(A.dot(T)))
print(T.T.dot(B.dot(T)))
print(T)


w, V = scipy.linalg.eig(A, B)
V = V.dot(numpy.diag(numpy.diag(V.T.dot(V))**-0.5))
print(V)
print(w)

