
"""
We have a matrix Q and we want to find the representation of a matrix Y = P Sigma [Q Qhat]*
in which [Q Qhat] is orthogonal.
"""

import numpy

numpy.set_printoptions(suppress=True)
numpy.random.seed(21)

p = 5
n = 10
m = 3

A = numpy.random.randn(m, n)
Y = numpy.random.randn(p, n)

P, s, Q = numpy.linalg.svd(A, full_matrices=False)
Q = Q.T

QQ = Q.dot(Q.conj().T)
Ybar = Y - Y.dot(QQ)

Pbar, sigmaBar, Qbar = numpy.linalg.svd(Ybar, full_matrices=False)
#s, Pbar = numpy.linalg.eig(Ybar.dot(Ybar.T))
Qbar = Ybar.T.dot(Pbar)
Qbar = Qbar.dot(numpy.diag(numpy.diag(Qbar.T.dot(Qbar))**-0.5))

print(Q.T.dot(Q))
print(Qbar.T.dot(Qbar))
print(Ybar.dot(Q))
print(Qbar.T.dot(Q))