import numpy
import logging
import sys
from apgl.graph import *
from apgl.generator import *
from apgl.util.ProfileUtils import ProfileUtils
from apgl.sandbox.IterativeSpectralClustering import * 

logging.basicConfig(stream=sys.stdout, level=logging.DEBUG)

class IterativeSpectralClusteringProfile(object):
    def __init__(self):
        numVertices = 500
        graph = SparseGraph(GeneralVertexList(numVertices))

        p = 0.1
        generator = ErdosRenyiGenerator(p)
        graph = generator.generate(graph)

        subgraphIndicesList = []
        for i in range(100, 500, 50):
            subgraphIndicesList.append(range(i))

        k1 = 5
        k2 = 20 

        self.graph = graph
        self.subgraphIndicesList = subgraphIndicesList
        self.clusterer = IterativeSpectralClustering(k1, k2)


    def profileClusterFromIterator(self):
        iterator = IncreasingSubgraphListIterator(self.graph, self.subgraphIndicesList)

        ProfileUtils.profile('self.clusterer.clusterFromIterator(iterator)', globals(), locals())

profiler = IterativeSpectralClusteringProfile()
profiler.profileClusterFromIterator() #19.7 